package io.mycat.beans.mysql;

/**
 * @author Junwen Chen
 */
public class InformationSchemaCreateTableSQLCollections {
    public static final String TABLES_CREATE_TABLE_SQL = "CREATE TABLE `TABLES` (\n"
            + "\tTABLE_CATALOG varchar(512) DEFAULT '' NOT NULL,\n"
            + "\tTABLE_SCHEMA varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tTABLE_NAME varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tTABLE_TYPE varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tENGINE varchar(64) DEFAULT NULL,\n"
            + "\tVERSION bigint(21) DEFAULT NULL,\n"
            + "\tROW_FORMAT varchar(10) DEFAULT NULL,\n"
            + "\tTABLE_ROWS bigint(21) DEFAULT NULL,\n"
            + "\tAVG_ROW_LENGTH bigint(21) DEFAULT NULL,\n"
            + "\tDATA_LENGTH bigint(21) DEFAULT NULL,\n"
            + "\tMAX_DATA_LENGTH bigint(21) DEFAULT NULL,\n"
            + "\tINDEX_LENGTH bigint(21) DEFAULT NULL,\n"
            + "\tDATA_FREE bigint(21) DEFAULT NULL,\n"
            + "\tAUTO_INCREMENT bigint(21) DEFAULT NULL,\n"
            + "\tCREATE_TIME datetime DEFAULT NULL,\n"
            + "\tUPDATE_TIME datetime DEFAULT NULL,\n"
            + "\tCHECK_TIME datetime DEFAULT NULL,\n"
            + "\tTABLE_COLLATION varchar(32) DEFAULT NULL,\n"
            + "\tCHECKSUM bigint(21) DEFAULT NULL,\n"
            + "\tCREATE_OPTIONS varchar(2048) DEFAULT NULL,\n"
            + "\tTABLE_COMMENT varchar(2048) DEFAULT '' NOT NULL,\n"
            + "\tMAX_INDEX_LENGTH bigint(21) DEFAULT NULL,\n"
            + "\tTEMPORARY varchar(1) DEFAULT NULL\n"
            + ")";

    public static final String INNODB_SYS_COLUMNS_CREATE_TABLE_SQL = "CREATE TABLE `INNODB_SYS_COLUMNS` (\n"
            + "\tTABLE_ID bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tNAME varchar(193) DEFAULT '' NOT NULL,\n"
            + "\tPOS bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tMTYPE int(11) DEFAULT 0 NOT NULL,\n"
            + "\tPRTYPE int(11) DEFAULT 0 NOT NULL,\n"
            + "\tLEN int(11) DEFAULT 0 NOT NULL\n"
            + ")";

    public static final String INNODB_SYS_TABLESPACES_CREATE_TABLE_SQL = "CREATE TABLE `INNODB_SYS_TABLESPACES` (\n"
            + "\tSPACE int(11) DEFAULT 0 NOT NULL,\n"
            + "\tNAME varchar(655) DEFAULT '' NOT NULL,\n"
            + "\tFLAG int(11) DEFAULT 0 NOT NULL,\n"
            + "\tROW_FORMAT varchar(22) DEFAULT NULL,\n"
            + "\tPAGE_SIZE int(11) DEFAULT 0 NOT NULL,\n"
            + "\tZIP_PAGE_SIZE int(11) DEFAULT 0 NOT NULL,\n"
            + "\tSPACE_TYPE varchar(10) DEFAULT NULL,\n"
            + "\tFS_BLOCK_SIZE int(11) DEFAULT 0 NOT NULL,\n"
            + "\tFILE_SIZE bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tALLOCATED_SIZE bigint(21) DEFAULT 0 NOT NULL\n"
            + ")";

    public static final String INNODB_FT_INDEX_TABLE_CREATE_TABLE_SQL = "CREATE TABLE `INNODB_FT_INDEX_TABLE` (\n"
            + "\tWORD varchar(337) DEFAULT '' NOT NULL,\n"
            + "\tFIRST_DOC_ID bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tLAST_DOC_ID bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tDOC_COUNT bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tDOC_ID bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tPOSITION bigint(21) DEFAULT 0 NOT NULL\n"
            + ")";

    public static final String CHECK_CONSTRAINTS_CREATE_TABLE_SQL = "CREATE TABLE `CHECK_CONSTRAINTS` (\n"
            + "\tCONSTRAINT_CATALOG varchar(512) DEFAULT '' NOT NULL,\n"
            + "\tCONSTRAINT_SCHEMA varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tCONSTRAINT_NAME varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tTABLE_NAME varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tCHECK_CLAUSE varchar(64) DEFAULT '' NOT NULL\n"
            + ")";

    public static final String PARTITIONS_CREATE_TABLE_SQL = "CREATE TABLE `PARTITIONS` (\n"
            + "\tTABLE_CATALOG varchar(512) DEFAULT '' NOT NULL,\n"
            + "\tTABLE_SCHEMA varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tTABLE_NAME varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tPARTITION_NAME varchar(64) DEFAULT NULL,\n"
            + "\tSUBPARTITION_NAME varchar(64) DEFAULT NULL,\n"
            + "\tPARTITION_ORDINAL_POSITION bigint(21) DEFAULT NULL,\n"
            + "\tSUBPARTITION_ORDINAL_POSITION bigint(21) DEFAULT NULL,\n"
            + "\tPARTITION_METHOD varchar(18) DEFAULT NULL,\n"
            + "\tSUBPARTITION_METHOD varchar(12) DEFAULT NULL,\n"
            + "\tPARTITION_EXPRESSION longtext DEFAULT NULL,\n"
            + "\tSUBPARTITION_EXPRESSION longtext DEFAULT NULL,\n"
            + "\tPARTITION_DESCRIPTION longtext DEFAULT NULL,\n"
            + "\tTABLE_ROWS bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tAVG_ROW_LENGTH bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tDATA_LENGTH bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tMAX_DATA_LENGTH bigint(21) DEFAULT NULL,\n"
            + "\tINDEX_LENGTH bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tDATA_FREE bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tCREATE_TIME datetime DEFAULT NULL,\n"
            + "\tUPDATE_TIME datetime DEFAULT NULL,\n"
            + "\tCHECK_TIME datetime DEFAULT NULL,\n"
            + "\tCHECKSUM bigint(21) DEFAULT NULL,\n"
            + "\tPARTITION_COMMENT varchar(80) DEFAULT '' NOT NULL,\n"
            + "\tNODEGROUP varchar(12) DEFAULT '' NOT NULL,\n"
            + "\tTABLESPACE_NAME varchar(64) DEFAULT NULL\n"
            + ")";

    public static final String TABLE_PRIVILEGES_CREATE_TABLE_SQL = "CREATE TABLE `TABLE_PRIVILEGES` (\n"
            + "\tGRANTEE varchar(190) DEFAULT '' NOT NULL,\n"
            + "\tTABLE_CATALOG varchar(512) DEFAULT '' NOT NULL,\n"
            + "\tTABLE_SCHEMA varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tTABLE_NAME varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tPRIVILEGE_TYPE varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tIS_GRANTABLE varchar(3) DEFAULT '' NOT NULL\n"
            + ")";

    public static final String TRIGGERS_CREATE_TABLE_SQL = "CREATE TABLE `TRIGGERS` (\n"
            + "\tTRIGGER_CATALOG varchar(512) DEFAULT '' NOT NULL,\n"
            + "\tTRIGGER_SCHEMA varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tTRIGGER_NAME varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tEVENT_MANIPULATION varchar(6) DEFAULT '' NOT NULL,\n"
            + "\tEVENT_OBJECT_CATALOG varchar(512) DEFAULT '' NOT NULL,\n"
            + "\tEVENT_OBJECT_SCHEMA varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tEVENT_OBJECT_TABLE varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tACTION_ORDER bigint(4) DEFAULT 0 NOT NULL,\n"
            + "\tACTION_CONDITION longtext DEFAULT NULL,\n"
            + "\tACTION_STATEMENT longtext DEFAULT '' NOT NULL,\n"
            + "\tACTION_ORIENTATION varchar(9) DEFAULT '' NOT NULL,\n"
            + "\tACTION_TIMING varchar(6) DEFAULT '' NOT NULL,\n"
            + "\tACTION_REFERENCE_OLD_TABLE varchar(64) DEFAULT NULL,\n"
            + "\tACTION_REFERENCE_NEW_TABLE varchar(64) DEFAULT NULL,\n"
            + "\tACTION_REFERENCE_OLD_ROW varchar(3) DEFAULT '' NOT NULL,\n"
            + "\tACTION_REFERENCE_NEW_ROW varchar(3) DEFAULT '' NOT NULL,\n"
            + "\tCREATED datetime(2) DEFAULT NULL,\n"
            + "\tSQL_MODE varchar(8192) DEFAULT '' NOT NULL,\n"
            + "\tDEFINER varchar(189) DEFAULT '' NOT NULL,\n"
            + "\tCHARACTER_SET_CLIENT varchar(32) DEFAULT '' NOT NULL,\n"
            + "\tCOLLATION_CONNECTION varchar(32) DEFAULT '' NOT NULL,\n"
            + "\tDATABASE_COLLATION varchar(32) DEFAULT '' NOT NULL\n"
            + ")";

    public static final String GEOMETRY_COLUMNS_CREATE_TABLE_SQL = "CREATE TABLE `GEOMETRY_COLUMNS` (\n"
            + "\tF_TABLE_CATALOG varchar(512) DEFAULT '' NOT NULL,\n"
            + "\tF_TABLE_SCHEMA varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tF_TABLE_NAME varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tF_GEOMETRY_COLUMN varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tG_TABLE_CATALOG varchar(512) DEFAULT '' NOT NULL,\n"
            + "\tG_TABLE_SCHEMA varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tG_TABLE_NAME varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tG_GEOMETRY_COLUMN varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tSTORAGE_TYPE tinyint(2) DEFAULT 0 NOT NULL,\n"
            + "\tGEOMETRY_TYPE int(7) DEFAULT 0 NOT NULL,\n"
            + "\tCOORD_DIMENSION tinyint(2) DEFAULT 0 NOT NULL,\n"
            + "\tMAX_PPR tinyint(2) DEFAULT 0 NOT NULL,\n"
            + "\tSRID smallint(5) DEFAULT 0 NOT NULL\n"
            + ")";

    public static final String EVENTS_CREATE_TABLE_SQL = "CREATE TABLE `EVENTS` (\n"
            + "\tEVENT_CATALOG varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tEVENT_SCHEMA varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tEVENT_NAME varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tDEFINER varchar(189) DEFAULT '' NOT NULL,\n"
            + "\tTIME_ZONE varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tEVENT_BODY varchar(8) DEFAULT '' NOT NULL,\n"
            + "\tEVENT_DEFINITION longtext DEFAULT '' NOT NULL,\n"
            + "\tEVENT_TYPE varchar(9) DEFAULT '' NOT NULL,\n"
            + "\tEXECUTE_AT datetime DEFAULT NULL,\n"
            + "\tINTERVAL_VALUE varchar(256) DEFAULT NULL,\n"
            + "\tINTERVAL_FIELD varchar(18) DEFAULT NULL,\n"
            + "\tSQL_MODE varchar(8192) DEFAULT '' NOT NULL,\n"
            + "\tSTARTS datetime DEFAULT NULL,\n"
            + "\tENDS datetime DEFAULT NULL,\n"
            + "\tSTATUS varchar(18) DEFAULT '' NOT NULL,\n"
            + "\tON_COMPLETION varchar(12) DEFAULT '' NOT NULL,\n"
            + "\tCREATED datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,\n"
            + "\tLAST_ALTERED datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,\n"
            + "\tLAST_EXECUTED datetime DEFAULT NULL,\n"
            + "\tEVENT_COMMENT varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tORIGINATOR bigint(10) DEFAULT 0 NOT NULL,\n"
            + "\tCHARACTER_SET_CLIENT varchar(32) DEFAULT '' NOT NULL,\n"
            + "\tCOLLATION_CONNECTION varchar(32) DEFAULT '' NOT NULL,\n"
            + "\tDATABASE_COLLATION varchar(32) DEFAULT '' NOT NULL\n"
            + ")";

    public static final String PARAMETERS_CREATE_TABLE_SQL = "CREATE TABLE `PARAMETERS` (\n"
            + "\tSPECIFIC_CATALOG varchar(512) DEFAULT '' NOT NULL,\n"
            + "\tSPECIFIC_SCHEMA varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tSPECIFIC_NAME varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tORDINAL_POSITION int(21) DEFAULT 0 NOT NULL,\n"
            + "\tPARAMETER_MODE varchar(5) DEFAULT NULL,\n"
            + "\tPARAMETER_NAME varchar(64) DEFAULT NULL,\n"
            + "\tDATA_TYPE varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tCHARACTER_MAXIMUM_LENGTH int(21) DEFAULT NULL,\n"
            + "\tCHARACTER_OCTET_LENGTH int(21) DEFAULT NULL,\n"
            + "\tNUMERIC_PRECISION int(21) DEFAULT NULL,\n"
            + "\tNUMERIC_SCALE int(21) DEFAULT NULL,\n"
            + "\tDATETIME_PRECISION bigint(21) DEFAULT NULL,\n"
            + "\tCHARACTER_SET_NAME varchar(64) DEFAULT NULL,\n"
            + "\tCOLLATION_NAME varchar(64) DEFAULT NULL,\n"
            + "\tDTD_IDENTIFIER longtext DEFAULT '' NOT NULL,\n"
            + "\tROUTINE_TYPE varchar(9) DEFAULT '' NOT NULL\n"
            + ")";

    public static final String INNODB_FT_DEFAULT_STOPWORD_CREATE_TABLE_SQL = "CREATE TABLE `INNODB_FT_DEFAULT_STOPWORD` (\n"
            + "\tvalue varchar(18) DEFAULT '' NOT NULL\n"
            + ")";

    public static final String INNODB_TABLESPACES_SCRUBBING_CREATE_TABLE_SQL = "CREATE TABLE `INNODB_TABLESPACES_SCRUBBING` (\n"
            + "\tSPACE bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tNAME varchar(655) DEFAULT NULL,\n"
            + "\tCOMPRESSED int(11) DEFAULT 0 NOT NULL,\n"
            + "\tLAST_SCRUB_COMPLETED datetime DEFAULT NULL,\n"
            + "\tCURRENT_SCRUB_STARTED datetime DEFAULT NULL,\n"
            + "\tCURRENT_SCRUB_ACTIVE_THREADS int(11) DEFAULT NULL,\n"
            + "\tCURRENT_SCRUB_PAGE_NUMBER bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tCURRENT_SCRUB_MAX_PAGE_NUMBER bigint(21) DEFAULT 0 NOT NULL\n"
            + ")";

    public static final String INNODB_LOCK_WAITS_CREATE_TABLE_SQL = "CREATE TABLE `INNODB_LOCK_WAITS` (\n"
            + "\trequesting_trx_id varchar(18) DEFAULT '' NOT NULL,\n"
            + "\trequested_lock_id varchar(81) DEFAULT '' NOT NULL,\n"
            + "\tblocking_trx_id varchar(18) DEFAULT '' NOT NULL,\n"
            + "\tblocking_lock_id varchar(81) DEFAULT '' NOT NULL\n"
            + ")";

    public static final String FILES_CREATE_TABLE_SQL = "CREATE TABLE `FILES` (\n"
            + "\tFILE_ID bigint(4) DEFAULT 0 NOT NULL,\n"
            + "\tFILE_NAME varchar(512) DEFAULT NULL,\n"
            + "\tFILE_TYPE varchar(20) DEFAULT '' NOT NULL,\n"
            + "\tTABLESPACE_NAME varchar(64) DEFAULT NULL,\n"
            + "\tTABLE_CATALOG varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tTABLE_SCHEMA varchar(64) DEFAULT NULL,\n"
            + "\tTABLE_NAME varchar(64) DEFAULT NULL,\n"
            + "\tLOGFILE_GROUP_NAME varchar(64) DEFAULT NULL,\n"
            + "\tLOGFILE_GROUP_NUMBER bigint(4) DEFAULT NULL,\n"
            + "\tENGINE varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tFULLTEXT_KEYS varchar(64) DEFAULT NULL,\n"
            + "\tDELETED_ROWS bigint(4) DEFAULT NULL,\n"
            + "\tUPDATE_COUNT bigint(4) DEFAULT NULL,\n"
            + "\tFREE_EXTENTS bigint(4) DEFAULT NULL,\n"
            + "\tTOTAL_EXTENTS bigint(4) DEFAULT NULL,\n"
            + "\tEXTENT_SIZE bigint(4) DEFAULT 0 NOT NULL,\n"
            + "\tINITIAL_SIZE bigint(21) DEFAULT NULL,\n"
            + "\tMAXIMUM_SIZE bigint(21) DEFAULT NULL,\n"
            + "\tAUTOEXTEND_SIZE bigint(21) DEFAULT NULL,\n"
            + "\tCREATION_TIME datetime DEFAULT NULL,\n"
            + "\tLAST_UPDATE_TIME datetime DEFAULT NULL,\n"
            + "\tLAST_ACCESS_TIME datetime DEFAULT NULL,\n"
            + "\tRECOVER_TIME bigint(4) DEFAULT NULL,\n"
            + "\tTRANSACTION_COUNTER bigint(4) DEFAULT NULL,\n"
            + "\tVERSION bigint(21) DEFAULT NULL,\n"
            + "\tROW_FORMAT varchar(10) DEFAULT NULL,\n"
            + "\tTABLE_ROWS bigint(21) DEFAULT NULL,\n"
            + "\tAVG_ROW_LENGTH bigint(21) DEFAULT NULL,\n"
            + "\tDATA_LENGTH bigint(21) DEFAULT NULL,\n"
            + "\tMAX_DATA_LENGTH bigint(21) DEFAULT NULL,\n"
            + "\tINDEX_LENGTH bigint(21) DEFAULT NULL,\n"
            + "\tDATA_FREE bigint(21) DEFAULT NULL,\n"
            + "\tCREATE_TIME datetime DEFAULT NULL,\n"
            + "\tUPDATE_TIME datetime DEFAULT NULL,\n"
            + "\tCHECK_TIME datetime DEFAULT NULL,\n"
            + "\tCHECKSUM bigint(21) DEFAULT NULL,\n"
            + "\tSTATUS varchar(20) DEFAULT '' NOT NULL,\n"
            + "\tEXTRA varchar(255) DEFAULT NULL\n"
            + ")";

    public static final String PLUGINS_CREATE_TABLE_SQL = "CREATE TABLE `PLUGINS` (\n"
            + "\tPLUGIN_NAME varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tPLUGIN_VERSION varchar(20) DEFAULT '' NOT NULL,\n"
            + "\tPLUGIN_STATUS varchar(16) DEFAULT '' NOT NULL,\n"
            + "\tPLUGIN_TYPE varchar(80) DEFAULT '' NOT NULL,\n"
            + "\tPLUGIN_TYPE_VERSION varchar(20) DEFAULT '' NOT NULL,\n"
            + "\tPLUGIN_LIBRARY varchar(64) DEFAULT NULL,\n"
            + "\tPLUGIN_LIBRARY_VERSION varchar(20) DEFAULT NULL,\n"
            + "\tPLUGIN_AUTHOR varchar(64) DEFAULT NULL,\n"
            + "\tPLUGIN_DESCRIPTION longtext DEFAULT NULL,\n"
            + "\tPLUGIN_LICENSE varchar(80) DEFAULT '' NOT NULL,\n"
            + "\tLOAD_OPTION varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tPLUGIN_MATURITY varchar(12) DEFAULT '' NOT NULL,\n"
            + "\tPLUGIN_AUTH_VERSION varchar(80) DEFAULT NULL\n"
            + ")";

    public static final String GLOBAL_STATUS_CREATE_TABLE_SQL = "CREATE TABLE `GLOBAL_STATUS` (\n"
            + "\tVARIABLE_NAME varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tVARIABLE_VALUE varchar(2048) DEFAULT '' NOT NULL\n"
            + ")";

    public static final String ALL_PLUGINS_CREATE_TABLE_SQL = "CREATE TABLE `ALL_PLUGINS` (\n"
            + "\tPLUGIN_NAME varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tPLUGIN_VERSION varchar(20) DEFAULT '' NOT NULL,\n"
            + "\tPLUGIN_STATUS varchar(16) DEFAULT '' NOT NULL,\n"
            + "\tPLUGIN_TYPE varchar(80) DEFAULT '' NOT NULL,\n"
            + "\tPLUGIN_TYPE_VERSION varchar(20) DEFAULT '' NOT NULL,\n"
            + "\tPLUGIN_LIBRARY varchar(64) DEFAULT NULL,\n"
            + "\tPLUGIN_LIBRARY_VERSION varchar(20) DEFAULT NULL,\n"
            + "\tPLUGIN_AUTHOR varchar(64) DEFAULT NULL,\n"
            + "\tPLUGIN_DESCRIPTION longtext DEFAULT NULL,\n"
            + "\tPLUGIN_LICENSE varchar(80) DEFAULT '' NOT NULL,\n"
            + "\tLOAD_OPTION varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tPLUGIN_MATURITY varchar(12) DEFAULT '' NOT NULL,\n"
            + "\tPLUGIN_AUTH_VERSION varchar(80) DEFAULT NULL\n"
            + ")";

    public static final String USER_STATISTICS_CREATE_TABLE_SQL = "CREATE TABLE `USER_STATISTICS` (\n"
            + "\tUSER varchar(128) DEFAULT '' NOT NULL,\n"
            + "\tTOTAL_CONNECTIONS int(11) DEFAULT 0 NOT NULL,\n"
            + "\tCONCURRENT_CONNECTIONS int(11) DEFAULT 0 NOT NULL,\n"
            + "\tCONNECTED_TIME int(11) DEFAULT 0 NOT NULL,\n"
            + "\tBUSY_TIME double DEFAULT 0 NOT NULL,\n"
            + "\tCPU_TIME double DEFAULT 0 NOT NULL,\n"
            + "\tBYTES_RECEIVED bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tBYTES_SENT bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tBINLOG_BYTES_WRITTEN bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tROWS_READ bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tROWS_SENT bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tROWS_DELETED bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tROWS_INSERTED bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tROWS_UPDATED bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tSELECT_COMMANDS bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tUPDATE_COMMANDS bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tOTHER_COMMANDS bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tCOMMIT_TRANSACTIONS bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tROLLBACK_TRANSACTIONS bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tDENIED_CONNECTIONS bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tLOST_CONNECTIONS bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tACCESS_DENIED bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tEMPTY_QUERIES bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tTOTAL_SSL_CONNECTIONS bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tMAX_STATEMENT_TIME_EXCEEDED bigint(21) DEFAULT 0 NOT NULL\n"
            + ")";

    public static final String INNODB_SYS_TABLESTATS_CREATE_TABLE_SQL = "CREATE TABLE `INNODB_SYS_TABLESTATS` (\n"
            + "\tTABLE_ID bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tNAME varchar(193) DEFAULT '' NOT NULL,\n"
            + "\tSTATS_INITIALIZED varchar(193) DEFAULT '' NOT NULL,\n"
            + "\tNUM_ROWS bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tCLUST_INDEX_SIZE bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tOTHER_INDEX_SIZE bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tMODIFIED_COUNTER bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tAUTOINC bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tREF_COUNT int(11) DEFAULT 0 NOT NULL\n"
            + ")";

    public static final String INNODB_SYS_SEMAPHORE_WAITS_CREATE_TABLE_SQL = "CREATE TABLE `INNODB_SYS_SEMAPHORE_WAITS` (\n"
            + "\tTHREAD_ID bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tOBJECT_NAME varchar(4000) DEFAULT NULL,\n"
            + "\tFILE varchar(4000) DEFAULT NULL,\n"
            + "\tLINE int(11) DEFAULT 0 NOT NULL,\n"
            + "\tWAIT_TIME bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tWAIT_OBJECT bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tWAIT_TYPE varchar(16) DEFAULT NULL,\n"
            + "\tHOLDER_THREAD_ID bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tHOLDER_FILE varchar(4000) DEFAULT NULL,\n"
            + "\tHOLDER_LINE int(11) DEFAULT 0 NOT NULL,\n"
            + "\tCREATED_FILE varchar(4000) DEFAULT NULL,\n"
            + "\tCREATED_LINE int(11) DEFAULT 0 NOT NULL,\n"
            + "\tWRITER_THREAD bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tRESERVATION_MODE varchar(16) DEFAULT NULL,\n"
            + "\tREADERS int(11) DEFAULT 0 NOT NULL,\n"
            + "\tWAITERS_FLAG bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tLOCK_WORD bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tLAST_WRITER_FILE varchar(4000) DEFAULT NULL,\n"
            + "\tLAST_WRITER_LINE int(11) DEFAULT 0 NOT NULL,\n"
            + "\tOS_WAIT_COUNT int(11) DEFAULT 0 NOT NULL\n"
            + ")";

    public static final String INNODB_CMP_PER_INDEX_RESET_CREATE_TABLE_SQL = "CREATE TABLE `INNODB_CMP_PER_INDEX_RESET` (\n"
            + "\tdatabase_name varchar(192) DEFAULT '' NOT NULL,\n"
            + "\ttable_name varchar(192) DEFAULT '' NOT NULL,\n"
            + "\tindex_name varchar(192) DEFAULT '' NOT NULL,\n"
            + "\tcompress_ops int(11) DEFAULT 0 NOT NULL,\n"
            + "\tcompress_ops_ok int(11) DEFAULT 0 NOT NULL,\n"
            + "\tcompress_time int(11) DEFAULT 0 NOT NULL,\n"
            + "\tuncompress_ops int(11) DEFAULT 0 NOT NULL,\n"
            + "\tuncompress_time int(11) DEFAULT 0 NOT NULL\n"
            + ")";

    public static final String TABLE_STATISTICS_CREATE_TABLE_SQL = "CREATE TABLE `TABLE_STATISTICS` (\n"
            + "\tTABLE_SCHEMA varchar(192) DEFAULT '' NOT NULL,\n"
            + "\tTABLE_NAME varchar(192) DEFAULT '' NOT NULL,\n"
            + "\tROWS_READ bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tROWS_CHANGED bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tROWS_CHANGED_X_INDEXES bigint(21) DEFAULT 0 NOT NULL\n"
            + ")";

    public static final String COLLATION_CHARACTER_SET_APPLICABILITY_CREATE_TABLE_SQL = "CREATE TABLE `COLLATION_CHARACTER_SET_APPLICABILITY` (\n"
            + "\tCOLLATION_NAME varchar(32) DEFAULT '' NOT NULL,\n"
            + "\tCHARACTER_SET_NAME varchar(32) DEFAULT '' NOT NULL\n"
            + ")";

    public static final String ENGINES_CREATE_TABLE_SQL = "CREATE TABLE `ENGINES` (\n"
            + "\tENGINE varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tSUPPORT varchar(8) DEFAULT '' NOT NULL,\n"
            + "\tCOMMENT varchar(160) DEFAULT '' NOT NULL,\n"
            + "\tTRANSACTIONS varchar(3) DEFAULT NULL,\n"
            + "\tXA varchar(3) DEFAULT NULL,\n"
            + "\tSAVEPOINTS varchar(3) DEFAULT NULL\n"
            + ")";

    public static final String KEY_COLUMN_USAGE_CREATE_TABLE_SQL = "CREATE TABLE `KEY_COLUMN_USAGE` (\n"
            + "\tCONSTRAINT_CATALOG varchar(512) DEFAULT '' NOT NULL,\n"
            + "\tCONSTRAINT_SCHEMA varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tCONSTRAINT_NAME varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tTABLE_CATALOG varchar(512) DEFAULT '' NOT NULL,\n"
            + "\tTABLE_SCHEMA varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tTABLE_NAME varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tCOLUMN_NAME varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tORDINAL_POSITION bigint(10) DEFAULT 0 NOT NULL,\n"
            + "\tPOSITION_IN_UNIQUE_CONSTRAINT bigint(10) DEFAULT NULL,\n"
            + "\tREFERENCED_TABLE_SCHEMA varchar(64) DEFAULT NULL,\n"
            + "\tREFERENCED_TABLE_NAME varchar(64) DEFAULT NULL,\n"
            + "\tREFERENCED_COLUMN_NAME varchar(64) DEFAULT NULL\n"
            + ")";

    public static final String GLOBAL_VARIABLES_CREATE_TABLE_SQL = "CREATE TABLE `GLOBAL_VARIABLES` (\n"
            + "\tVARIABLE_NAME varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tVARIABLE_VALUE varchar(2048) DEFAULT '' NOT NULL\n"
            + ")";

    public static final String INNODB_LOCKS_CREATE_TABLE_SQL = "CREATE TABLE `INNODB_LOCKS` (\n"
            + "\tlock_id varchar(81) DEFAULT '' NOT NULL,\n"
            + "\tlock_trx_id varchar(18) DEFAULT '' NOT NULL,\n"
            + "\tlock_mode varchar(32) DEFAULT '' NOT NULL,\n"
            + "\tlock_type varchar(32) DEFAULT '' NOT NULL,\n"
            + "\tlock_table varchar(1024) DEFAULT '' NOT NULL,\n"
            + "\tlock_index varchar(1024) DEFAULT NULL,\n"
            + "\tlock_space bigint(21) DEFAULT NULL,\n"
            + "\tlock_page bigint(21) DEFAULT NULL,\n"
            + "\tlock_rec bigint(21) DEFAULT NULL,\n"
            + "\tlock_data varchar(8192) DEFAULT NULL\n"
            + ")";

    public static final String INNODB_SYS_FOREIGN_COLS_CREATE_TABLE_SQL = "CREATE TABLE `INNODB_SYS_FOREIGN_COLS` (\n"
            + "\tID varchar(193) DEFAULT '' NOT NULL,\n"
            + "\tFOR_COL_NAME varchar(193) DEFAULT '' NOT NULL,\n"
            + "\tREF_COL_NAME varchar(193) DEFAULT '' NOT NULL,\n"
            + "\tPOS int(11) DEFAULT 0 NOT NULL\n"
            + ")";

    public static final String INNODB_BUFFER_PAGE_CREATE_TABLE_SQL = "CREATE TABLE `INNODB_BUFFER_PAGE` (\n"
            + "\tPOOL_ID bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tBLOCK_ID bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tSPACE bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tPAGE_NUMBER bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tPAGE_TYPE varchar(64) DEFAULT NULL,\n"
            + "\tFLUSH_TYPE bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tFIX_COUNT bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tIS_HASHED varchar(3) DEFAULT NULL,\n"
            + "\tNEWEST_MODIFICATION bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tOLDEST_MODIFICATION bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tACCESS_TIME bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tTABLE_NAME varchar(1024) DEFAULT NULL,\n"
            + "\tINDEX_NAME varchar(1024) DEFAULT NULL,\n"
            + "\tNUMBER_RECORDS bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tDATA_SIZE bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tCOMPRESSED_SIZE bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tPAGE_STATE varchar(64) DEFAULT NULL,\n"
            + "\tIO_FIX varchar(64) DEFAULT NULL,\n"
            + "\tIS_OLD varchar(3) DEFAULT NULL,\n"
            + "\tFREE_PAGE_CLOCK bigint(21) DEFAULT 0 NOT NULL\n"
            + ")";

    public static final String SESSION_STATUS_CREATE_TABLE_SQL = "CREATE TABLE `SESSION_STATUS` (\n"
            + "\tVARIABLE_NAME varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tVARIABLE_VALUE varchar(2048) DEFAULT '' NOT NULL\n"
            + ")";

    public static final String INNODB_SYS_DATAFILES_CREATE_TABLE_SQL = "CREATE TABLE `INNODB_SYS_DATAFILES` (\n"
            + "\tSPACE int(11) DEFAULT 0 NOT NULL,\n"
            + "\tPATH varchar(4000) DEFAULT '' NOT NULL\n"
            + ")";

    public static final String INNODB_CMP_CREATE_TABLE_SQL = "CREATE TABLE `INNODB_CMP` (\n"
            + "\tpage_size int(5) DEFAULT 0 NOT NULL,\n"
            + "\tcompress_ops int(11) DEFAULT 0 NOT NULL,\n"
            + "\tcompress_ops_ok int(11) DEFAULT 0 NOT NULL,\n"
            + "\tcompress_time int(11) DEFAULT 0 NOT NULL,\n"
            + "\tuncompress_ops int(11) DEFAULT 0 NOT NULL,\n"
            + "\tuncompress_time int(11) DEFAULT 0 NOT NULL\n"
            + ")";

    public static final String KEY_CACHES_CREATE_TABLE_SQL = "CREATE TABLE `KEY_CACHES` (\n"
            + "\tKEY_CACHE_NAME varchar(192) DEFAULT '' NOT NULL,\n"
            + "\tSEGMENTS int(3) DEFAULT NULL,\n"
            + "\tSEGMENT_NUMBER int(3) DEFAULT NULL,\n"
            + "\tFULL_SIZE bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tBLOCK_SIZE bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tUSED_BLOCKS bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tUNUSED_BLOCKS bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tDIRTY_BLOCKS bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tREAD_REQUESTS bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tREADS bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tWRITE_REQUESTS bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tWRITES bigint(21) DEFAULT 0 NOT NULL\n"
            + ")";

    public static final String INNODB_CMPMEM_RESET_CREATE_TABLE_SQL = "CREATE TABLE `INNODB_CMPMEM_RESET` (\n"
            + "\tpage_size int(5) DEFAULT 0 NOT NULL,\n"
            + "\tbuffer_pool_instance int(11) DEFAULT 0 NOT NULL,\n"
            + "\tpages_used int(11) DEFAULT 0 NOT NULL,\n"
            + "\tpages_free int(11) DEFAULT 0 NOT NULL,\n"
            + "\trelocation_ops bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\trelocation_time int(11) DEFAULT 0 NOT NULL\n"
            + ")";

    public static final String INNODB_SYS_VIRTUAL_CREATE_TABLE_SQL = "CREATE TABLE `INNODB_SYS_VIRTUAL` (\n"
            + "\tTABLE_ID bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tPOS int(11) DEFAULT 0 NOT NULL,\n"
            + "\tBASE_POS int(11) DEFAULT 0 NOT NULL\n"
            + ")";

    public static final String APPLICABLE_ROLES_CREATE_TABLE_SQL = "CREATE TABLE `APPLICABLE_ROLES` (\n"
            + "\tGRANTEE varchar(190) DEFAULT '' NOT NULL,\n"
            + "\tROLE_NAME varchar(128) DEFAULT '' NOT NULL,\n"
            + "\tIS_GRANTABLE varchar(3) DEFAULT '' NOT NULL,\n"
            + "\tIS_DEFAULT varchar(3) DEFAULT NULL\n"
            + ")";

    public static final String INNODB_SYS_FIELDS_CREATE_TABLE_SQL = "CREATE TABLE `INNODB_SYS_FIELDS` (\n"
            + "\tINDEX_ID bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tNAME varchar(193) DEFAULT '' NOT NULL,\n"
            + "\tPOS int(11) DEFAULT 0 NOT NULL\n"
            + ")";

    public static final String TABLESPACES_CREATE_TABLE_SQL = "CREATE TABLE `TABLESPACES` (\n"
            + "\tTABLESPACE_NAME varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tENGINE varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tTABLESPACE_TYPE varchar(64) DEFAULT NULL,\n"
            + "\tLOGFILE_GROUP_NAME varchar(64) DEFAULT NULL,\n"
            + "\tEXTENT_SIZE bigint(21) DEFAULT NULL,\n"
            + "\tAUTOEXTEND_SIZE bigint(21) DEFAULT NULL,\n"
            + "\tMAXIMUM_SIZE bigint(21) DEFAULT NULL,\n"
            + "\tNODEGROUP_ID bigint(21) DEFAULT NULL,\n"
            + "\tTABLESPACE_COMMENT varchar(2048) DEFAULT NULL\n"
            + ")";

    public static final String REFERENTIAL_CONSTRAINTS_CREATE_TABLE_SQL = "CREATE TABLE `REFERENTIAL_CONSTRAINTS` (\n"
            + "\tCONSTRAINT_CATALOG varchar(512) DEFAULT '' NOT NULL,\n"
            + "\tCONSTRAINT_SCHEMA varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tCONSTRAINT_NAME varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tUNIQUE_CONSTRAINT_CATALOG varchar(512) DEFAULT '' NOT NULL,\n"
            + "\tUNIQUE_CONSTRAINT_SCHEMA varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tUNIQUE_CONSTRAINT_NAME varchar(64) DEFAULT NULL,\n"
            + "\tMATCH_OPTION varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tUPDATE_RULE varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tDELETE_RULE varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tTABLE_NAME varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tREFERENCED_TABLE_NAME varchar(64) DEFAULT '' NOT NULL\n"
            + ")";

    public static final String INNODB_SYS_TABLES_CREATE_TABLE_SQL = "CREATE TABLE `INNODB_SYS_TABLES` (\n"
            + "\tTABLE_ID bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tNAME varchar(655) DEFAULT '' NOT NULL,\n"
            + "\tFLAG int(11) DEFAULT 0 NOT NULL,\n"
            + "\tN_COLS int(11) DEFAULT 0 NOT NULL,\n"
            + "\tSPACE int(11) DEFAULT 0 NOT NULL,\n"
            + "\tROW_FORMAT varchar(12) DEFAULT NULL,\n"
            + "\tZIP_PAGE_SIZE int(11) DEFAULT 0 NOT NULL,\n"
            + "\tSPACE_TYPE varchar(10) DEFAULT NULL\n"
            + ")";

    public static final String SCHEMATA_CREATE_TABLE_SQL = "CREATE TABLE `SCHEMATA` (\n"
            + "\tCATALOG_NAME varchar(512) DEFAULT '' NOT NULL,\n"
            + "\tSCHEMA_NAME varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tDEFAULT_CHARACTER_SET_NAME varchar(32) DEFAULT '' NOT NULL,\n"
            + "\tDEFAULT_COLLATION_NAME varchar(32) DEFAULT '' NOT NULL,\n"
            + "\tSQL_PATH varchar(512) DEFAULT NULL\n"
            + ")";

    public static final String INNODB_FT_BEING_DELETED_CREATE_TABLE_SQL = "CREATE TABLE `INNODB_FT_BEING_DELETED` (\n"
            + "\tDOC_ID bigint(21) DEFAULT 0 NOT NULL\n"
            + ")";

    public static final String ENABLED_ROLES_CREATE_TABLE_SQL = "CREATE TABLE `ENABLED_ROLES` (\n"
            + "\tROLE_NAME varchar(128) DEFAULT NULL\n"
            + ")";

    public static final String COLUMNS_CREATE_TABLE_SQL = "CREATE TABLE `COLUMNS` (\n"
            + "\tTABLE_CATALOG varchar(512) DEFAULT '' NOT NULL,\n"
            + "\tTABLE_SCHEMA varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tTABLE_NAME varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tCOLUMN_NAME varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tORDINAL_POSITION bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tCOLUMN_DEFAULT longtext DEFAULT NULL,\n"
            + "\tIS_NULLABLE varchar(3) DEFAULT '' NOT NULL,\n"
            + "\tDATA_TYPE varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tCHARACTER_MAXIMUM_LENGTH bigint(21) DEFAULT NULL,\n"
            + "\tCHARACTER_OCTET_LENGTH bigint(21) DEFAULT NULL,\n"
            + "\tNUMERIC_PRECISION bigint(21) DEFAULT NULL,\n"
            + "\tNUMERIC_SCALE bigint(21) DEFAULT NULL,\n"
            + "\tDATETIME_PRECISION bigint(21) DEFAULT NULL,\n"
            + "\tCHARACTER_SET_NAME varchar(32) DEFAULT NULL,\n"
            + "\tCOLLATION_NAME varchar(32) DEFAULT NULL,\n"
            + "\tCOLUMN_TYPE longtext DEFAULT '' NOT NULL,\n"
            + "\tCOLUMN_KEY varchar(3) DEFAULT '' NOT NULL,\n"
            + "\tEXTRA varchar(30) DEFAULT '' NOT NULL,\n"
            + "\tPRIVILEGES varchar(80) DEFAULT '' NOT NULL,\n"
            + "\tCOLUMN_COMMENT varchar(1024) DEFAULT '' NOT NULL,\n"
            + "\tIS_GENERATED varchar(6) DEFAULT '' NOT NULL,\n"
            + "\tGENERATION_EXPRESSION longtext DEFAULT NULL\n"
            + ")";

    public static final String INNODB_BUFFER_POOL_STATS_CREATE_TABLE_SQL = "CREATE TABLE `INNODB_BUFFER_POOL_STATS` (\n"
            + "\tPOOL_ID bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tPOOL_SIZE bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tFREE_BUFFERS bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tDATABASE_PAGES bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tOLD_DATABASE_PAGES bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tMODIFIED_DATABASE_PAGES bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tPENDING_DECOMPRESS bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tPENDING_READS bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tPENDING_FLUSH_LRU bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tPENDING_FLUSH_LIST bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tPAGES_MADE_YOUNG bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tPAGES_NOT_MADE_YOUNG bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tPAGES_MADE_YOUNG_RATE double DEFAULT 0 NOT NULL,\n"
            + "\tPAGES_MADE_NOT_YOUNG_RATE double DEFAULT 0 NOT NULL,\n"
            + "\tNUMBER_PAGES_READ bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tNUMBER_PAGES_CREATED bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tNUMBER_PAGES_WRITTEN bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tPAGES_READ_RATE double DEFAULT 0 NOT NULL,\n"
            + "\tPAGES_CREATE_RATE double DEFAULT 0 NOT NULL,\n"
            + "\tPAGES_WRITTEN_RATE double DEFAULT 0 NOT NULL,\n"
            + "\tNUMBER_PAGES_GET bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tHIT_RATE bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tYOUNG_MAKE_PER_THOUSAND_GETS bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tNOT_YOUNG_MAKE_PER_THOUSAND_GETS bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tNUMBER_PAGES_READ_AHEAD bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tNUMBER_READ_AHEAD_EVICTED bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tREAD_AHEAD_RATE double DEFAULT 0 NOT NULL,\n"
            + "\tREAD_AHEAD_EVICTED_RATE double DEFAULT 0 NOT NULL,\n"
            + "\tLRU_IO_TOTAL bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tLRU_IO_CURRENT bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tUNCOMPRESS_TOTAL bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tUNCOMPRESS_CURRENT bigint(21) DEFAULT 0 NOT NULL\n"
            + ")";

    public static final String INNODB_CMP_PER_INDEX_CREATE_TABLE_SQL = "CREATE TABLE `INNODB_CMP_PER_INDEX` (\n"
            + "\tdatabase_name varchar(192) DEFAULT '' NOT NULL,\n"
            + "\ttable_name varchar(192) DEFAULT '' NOT NULL,\n"
            + "\tindex_name varchar(192) DEFAULT '' NOT NULL,\n"
            + "\tcompress_ops int(11) DEFAULT 0 NOT NULL,\n"
            + "\tcompress_ops_ok int(11) DEFAULT 0 NOT NULL,\n"
            + "\tcompress_time int(11) DEFAULT 0 NOT NULL,\n"
            + "\tuncompress_ops int(11) DEFAULT 0 NOT NULL,\n"
            + "\tuncompress_time int(11) DEFAULT 0 NOT NULL\n"
            + ")";

    public static final String INNODB_MUTEXES_CREATE_TABLE_SQL = "CREATE TABLE `INNODB_MUTEXES` (\n"
            + "\tNAME varchar(4000) DEFAULT '' NOT NULL,\n"
            + "\tCREATE_FILE varchar(4000) DEFAULT '' NOT NULL,\n"
            + "\tCREATE_LINE int(11) DEFAULT 0 NOT NULL,\n"
            + "\tOS_WAITS bigint(21) DEFAULT 0 NOT NULL\n"
            + ")";

    public static final String INNODB_BUFFER_PAGE_LRU_CREATE_TABLE_SQL = "CREATE TABLE `INNODB_BUFFER_PAGE_LRU` (\n"
            + "\tPOOL_ID bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tLRU_POSITION bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tSPACE bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tPAGE_NUMBER bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tPAGE_TYPE varchar(64) DEFAULT NULL,\n"
            + "\tFLUSH_TYPE bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tFIX_COUNT bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tIS_HASHED varchar(3) DEFAULT NULL,\n"
            + "\tNEWEST_MODIFICATION bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tOLDEST_MODIFICATION bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tACCESS_TIME bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tTABLE_NAME varchar(1024) DEFAULT NULL,\n"
            + "\tINDEX_NAME varchar(1024) DEFAULT NULL,\n"
            + "\tNUMBER_RECORDS bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tDATA_SIZE bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tCOMPRESSED_SIZE bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tCOMPRESSED varchar(3) DEFAULT NULL,\n"
            + "\tIO_FIX varchar(64) DEFAULT NULL,\n"
            + "\tIS_OLD varchar(3) DEFAULT NULL,\n"
            + "\tFREE_PAGE_CLOCK bigint(21) DEFAULT 0 NOT NULL\n"
            + ")";

    public static final String INNODB_FT_CONFIG_CREATE_TABLE_SQL = "CREATE TABLE `INNODB_FT_CONFIG` (\n"
            + "\tKEY varchar(193) DEFAULT '' NOT NULL,\n"
            + "\tVALUE varchar(193) DEFAULT '' NOT NULL\n"
            + ")";

    public static final String SYSTEM_VARIABLES_CREATE_TABLE_SQL = "CREATE TABLE `SYSTEM_VARIABLES` (\n"
            + "\tVARIABLE_NAME varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tSESSION_VALUE varchar(2048) DEFAULT NULL,\n"
            + "\tGLOBAL_VALUE varchar(2048) DEFAULT NULL,\n"
            + "\tGLOBAL_VALUE_ORIGIN varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tDEFAULT_VALUE varchar(2048) DEFAULT NULL,\n"
            + "\tVARIABLE_SCOPE varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tVARIABLE_TYPE varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tVARIABLE_COMMENT varchar(2048) DEFAULT '' NOT NULL,\n"
            + "\tNUMERIC_MIN_VALUE varchar(21) DEFAULT NULL,\n"
            + "\tNUMERIC_MAX_VALUE varchar(21) DEFAULT NULL,\n"
            + "\tNUMERIC_BLOCK_SIZE varchar(21) DEFAULT NULL,\n"
            + "\tENUM_VALUE_LIST longtext DEFAULT NULL,\n"
            + "\tREAD_ONLY varchar(3) DEFAULT '' NOT NULL,\n"
            + "\tCOMMAND_LINE_ARGUMENT varchar(64) DEFAULT NULL\n"
            + ")";

    public static final String TABLE_CONSTRAINTS_CREATE_TABLE_SQL = "CREATE TABLE `TABLE_CONSTRAINTS` (\n"
            + "\tCONSTRAINT_CATALOG varchar(512) DEFAULT '' NOT NULL,\n"
            + "\tCONSTRAINT_SCHEMA varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tCONSTRAINT_NAME varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tTABLE_SCHEMA varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tTABLE_NAME varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tCONSTRAINT_TYPE varchar(64) DEFAULT '' NOT NULL\n"
            + ")";

    public static final String CLIENT_STATISTICS_CREATE_TABLE_SQL = "CREATE TABLE `CLIENT_STATISTICS` (\n"
            + "\tCLIENT varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tTOTAL_CONNECTIONS bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tCONCURRENT_CONNECTIONS bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tCONNECTED_TIME bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tBUSY_TIME double DEFAULT 0 NOT NULL,\n"
            + "\tCPU_TIME double DEFAULT 0 NOT NULL,\n"
            + "\tBYTES_RECEIVED bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tBYTES_SENT bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tBINLOG_BYTES_WRITTEN bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tROWS_READ bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tROWS_SENT bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tROWS_DELETED bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tROWS_INSERTED bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tROWS_UPDATED bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tSELECT_COMMANDS bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tUPDATE_COMMANDS bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tOTHER_COMMANDS bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tCOMMIT_TRANSACTIONS bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tROLLBACK_TRANSACTIONS bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tDENIED_CONNECTIONS bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tLOST_CONNECTIONS bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tACCESS_DENIED bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tEMPTY_QUERIES bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tTOTAL_SSL_CONNECTIONS bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tMAX_STATEMENT_TIME_EXCEEDED bigint(21) DEFAULT 0 NOT NULL\n"
            + ")";

    public static final String PROFILING_CREATE_TABLE_SQL = "CREATE TABLE `PROFILING` (\n"
            + "\tQUERY_ID int(20) DEFAULT 0 NOT NULL,\n"
            + "\tSEQ int(20) DEFAULT 0 NOT NULL,\n"
            + "\tSTATE varchar(30) DEFAULT '' NOT NULL,\n"
            + "\tDURATION decimal(9, 6) DEFAULT 0.000000 NOT NULL,\n"
            + "\tCPU_USER decimal(9, 6) DEFAULT NULL,\n"
            + "\tCPU_SYSTEM decimal(9, 6) DEFAULT NULL,\n"
            + "\tCONTEXT_VOLUNTARY int(20) DEFAULT NULL,\n"
            + "\tCONTEXT_INVOLUNTARY int(20) DEFAULT NULL,\n"
            + "\tBLOCK_OPS_IN int(20) DEFAULT NULL,\n"
            + "\tBLOCK_OPS_OUT int(20) DEFAULT NULL,\n"
            + "\tMESSAGES_SENT int(20) DEFAULT NULL,\n"
            + "\tMESSAGES_RECEIVED int(20) DEFAULT NULL,\n"
            + "\tPAGE_FAULTS_MAJOR int(20) DEFAULT NULL,\n"
            + "\tPAGE_FAULTS_MINOR int(20) DEFAULT NULL,\n"
            + "\tSWAPS int(20) DEFAULT NULL,\n"
            + "\tSOURCE_FUNCTION varchar(30) DEFAULT NULL,\n"
            + "\tSOURCE_FILE varchar(20) DEFAULT NULL,\n"
            + "\tSOURCE_LINE int(20) DEFAULT NULL\n"
            + ")";

    public static final String INNODB_TABLESPACES_ENCRYPTION_CREATE_TABLE_SQL = "CREATE TABLE `INNODB_TABLESPACES_ENCRYPTION` (\n"
            + "\tSPACE int(11) DEFAULT 0 NOT NULL,\n"
            + "\tNAME varchar(655) DEFAULT NULL,\n"
            + "\tENCRYPTION_SCHEME int(11) DEFAULT 0 NOT NULL,\n"
            + "\tKEYSERVER_REQUESTS int(11) DEFAULT 0 NOT NULL,\n"
            + "\tMIN_KEY_VERSION int(11) DEFAULT 0 NOT NULL,\n"
            + "\tCURRENT_KEY_VERSION int(11) DEFAULT 0 NOT NULL,\n"
            + "\tKEY_ROTATION_PAGE_NUMBER bigint(21) DEFAULT NULL,\n"
            + "\tKEY_ROTATION_MAX_PAGE_NUMBER bigint(21) DEFAULT NULL,\n"
            + "\tCURRENT_KEY_ID int(11) DEFAULT 0 NOT NULL,\n"
            + "\tROTATING_OR_FLUSHING int(1) DEFAULT 0 NOT NULL\n"
            + ")";

    public static final String INNODB_SYS_FOREIGN_CREATE_TABLE_SQL = "CREATE TABLE `INNODB_SYS_FOREIGN` (\n"
            + "\tID varchar(193) DEFAULT '' NOT NULL,\n"
            + "\tFOR_NAME varchar(193) DEFAULT '' NOT NULL,\n"
            + "\tREF_NAME varchar(193) DEFAULT '' NOT NULL,\n"
            + "\tN_COLS int(11) DEFAULT 0 NOT NULL,\n"
            + "\tTYPE int(11) DEFAULT 0 NOT NULL\n"
            + ")";

    public static final String COLLATIONS_CREATE_TABLE_SQL = "CREATE TABLE `COLLATIONS` (\n"
            + "\tCOLLATION_NAME varchar(32) DEFAULT '' NOT NULL,\n"
            + "\tCHARACTER_SET_NAME varchar(32) DEFAULT '' NOT NULL,\n"
            + "\tID bigint(11) DEFAULT 0 NOT NULL,\n"
            + "\tIS_DEFAULT varchar(3) DEFAULT '' NOT NULL,\n"
            + "\tIS_COMPILED varchar(3) DEFAULT '' NOT NULL,\n"
            + "\tSORTLEN bigint(3) DEFAULT 0 NOT NULL\n"
            + ")";

    public static final String INNODB_CMPMEM_CREATE_TABLE_SQL = "CREATE TABLE `INNODB_CMPMEM` (\n"
            + "\tpage_size int(5) DEFAULT 0 NOT NULL,\n"
            + "\tbuffer_pool_instance int(11) DEFAULT 0 NOT NULL,\n"
            + "\tpages_used int(11) DEFAULT 0 NOT NULL,\n"
            + "\tpages_free int(11) DEFAULT 0 NOT NULL,\n"
            + "\trelocation_ops bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\trelocation_time int(11) DEFAULT 0 NOT NULL\n"
            + ")";

    public static final String INNODB_TRX_CREATE_TABLE_SQL = "CREATE TABLE `INNODB_TRX` (\n"
            + "\ttrx_id varchar(18) DEFAULT '' NOT NULL,\n"
            + "\ttrx_state varchar(13) DEFAULT '' NOT NULL,\n"
            + "\ttrx_started datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,\n"
            + "\ttrx_requested_lock_id varchar(81) DEFAULT NULL,\n"
            + "\ttrx_wait_started datetime DEFAULT NULL,\n"
            + "\ttrx_weight bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\ttrx_mysql_thread_id bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\ttrx_query varchar(1024) DEFAULT NULL,\n"
            + "\ttrx_operation_state varchar(64) DEFAULT NULL,\n"
            + "\ttrx_tables_in_use bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\ttrx_tables_locked bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\ttrx_lock_structs bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\ttrx_lock_memory_bytes bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\ttrx_rows_locked bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\ttrx_rows_modified bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\ttrx_concurrency_tickets bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\ttrx_isolation_level varchar(16) DEFAULT '' NOT NULL,\n"
            + "\ttrx_unique_checks int(1) DEFAULT 0 NOT NULL,\n"
            + "\ttrx_foreign_key_checks int(1) DEFAULT 0 NOT NULL,\n"
            + "\ttrx_last_foreign_key_error varchar(256) DEFAULT NULL,\n"
            + "\ttrx_is_read_only int(1) DEFAULT 0 NOT NULL,\n"
            + "\ttrx_autocommit_non_locking int(1) DEFAULT 0 NOT NULL\n"
            + ")";

    public static final String CHARACTER_SETS_CREATE_TABLE_SQL = "CREATE TABLE `CHARACTER_SETS` (\n"
            + "\tCHARACTER_SET_NAME varchar(32) DEFAULT '' NOT NULL,\n"
            + "\tDEFAULT_COLLATE_NAME varchar(32) DEFAULT '' NOT NULL,\n"
            + "\tDESCRIPTION varchar(60) DEFAULT '' NOT NULL,\n"
            + "\tMAXLEN bigint(3) DEFAULT 0 NOT NULL\n"
            + ")";

    public static final String INDEX_STATISTICS_CREATE_TABLE_SQL = "CREATE TABLE `INDEX_STATISTICS` (\n"
            + "\tTABLE_SCHEMA varchar(192) DEFAULT '' NOT NULL,\n"
            + "\tTABLE_NAME varchar(192) DEFAULT '' NOT NULL,\n"
            + "\tINDEX_NAME varchar(192) DEFAULT '' NOT NULL,\n"
            + "\tROWS_READ bigint(21) DEFAULT 0 NOT NULL\n"
            + ")";

    public static final String INNODB_FT_DELETED_CREATE_TABLE_SQL = "CREATE TABLE `INNODB_FT_DELETED` (\n"
            + "\tDOC_ID bigint(21) DEFAULT 0 NOT NULL\n"
            + ")";

    public static final String STATISTICS_CREATE_TABLE_SQL = "CREATE TABLE `STATISTICS` (\n"
            + "\tTABLE_CATALOG varchar(512) DEFAULT '' NOT NULL,\n"
            + "\tTABLE_SCHEMA varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tTABLE_NAME varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tNON_UNIQUE bigint(1) DEFAULT 0 NOT NULL,\n"
            + "\tINDEX_SCHEMA varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tINDEX_NAME varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tSEQ_IN_INDEX bigint(2) DEFAULT 0 NOT NULL,\n"
            + "\tCOLUMN_NAME varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tCOLLATION varchar(1) DEFAULT NULL,\n"
            + "\tCARDINALITY bigint(21) DEFAULT NULL,\n"
            + "\tSUB_PART bigint(3) DEFAULT NULL,\n"
            + "\tPACKED varchar(10) DEFAULT NULL,\n"
            + "\tNULLABLE varchar(3) DEFAULT '' NOT NULL,\n"
            + "\tINDEX_TYPE varchar(16) DEFAULT '' NOT NULL,\n"
            + "\tCOMMENT varchar(16) DEFAULT NULL,\n"
            + "\tINDEX_COMMENT varchar(1024) DEFAULT '' NOT NULL\n"
            + ")";

    public static final String VIEWS_CREATE_TABLE_SQL = "CREATE TABLE `VIEWS` (\n"
            + "\tTABLE_CATALOG varchar(512) DEFAULT '' NOT NULL,\n"
            + "\tTABLE_SCHEMA varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tTABLE_NAME varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tVIEW_DEFINITION longtext DEFAULT '' NOT NULL,\n"
            + "\tCHECK_OPTION varchar(8) DEFAULT '' NOT NULL,\n"
            + "\tIS_UPDATABLE varchar(3) DEFAULT '' NOT NULL,\n"
            + "\tDEFINER varchar(189) DEFAULT '' NOT NULL,\n"
            + "\tSECURITY_TYPE varchar(7) DEFAULT '' NOT NULL,\n"
            + "\tCHARACTER_SET_CLIENT varchar(32) DEFAULT '' NOT NULL,\n"
            + "\tCOLLATION_CONNECTION varchar(32) DEFAULT '' NOT NULL,\n"
            + "\tALGORITHM varchar(10) DEFAULT '' NOT NULL\n"
            + ")";

    public static final String COLUMN_PRIVILEGES_CREATE_TABLE_SQL = "CREATE TABLE `COLUMN_PRIVILEGES` (\n"
            + "\tGRANTEE varchar(190) DEFAULT '' NOT NULL,\n"
            + "\tTABLE_CATALOG varchar(512) DEFAULT '' NOT NULL,\n"
            + "\tTABLE_SCHEMA varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tTABLE_NAME varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tCOLUMN_NAME varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tPRIVILEGE_TYPE varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tIS_GRANTABLE varchar(3) DEFAULT '' NOT NULL\n"
            + ")";

    public static final String user_variables_CREATE_TABLE_SQL = "CREATE TABLE `user_variables` (\n"
            + "\tVARIABLE_NAME varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tVARIABLE_VALUE varchar(2048) DEFAULT NULL,\n"
            + "\tVARIABLE_TYPE varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tCHARACTER_SET_NAME varchar(32) DEFAULT NULL\n"
            + ")";

    public static final String SESSION_VARIABLES_CREATE_TABLE_SQL = "CREATE TABLE `SESSION_VARIABLES` (\n"
            + "\tVARIABLE_NAME varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tVARIABLE_VALUE varchar(2048) DEFAULT '' NOT NULL\n"
            + ")";

    public static final String INNODB_METRICS_CREATE_TABLE_SQL = "CREATE TABLE `INNODB_METRICS` (\n"
            + "\tNAME varchar(193) DEFAULT '' NOT NULL,\n"
            + "\tSUBSYSTEM varchar(193) DEFAULT '' NOT NULL,\n"
            + "\tCOUNT bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tMAX_COUNT bigint(21) DEFAULT NULL,\n"
            + "\tMIN_COUNT bigint(21) DEFAULT NULL,\n"
            + "\tAVG_COUNT double DEFAULT NULL,\n"
            + "\tCOUNT_RESET bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tMAX_COUNT_RESET bigint(21) DEFAULT NULL,\n"
            + "\tMIN_COUNT_RESET bigint(21) DEFAULT NULL,\n"
            + "\tAVG_COUNT_RESET double DEFAULT NULL,\n"
            + "\tTIME_ENABLED datetime DEFAULT NULL,\n"
            + "\tTIME_DISABLED datetime DEFAULT NULL,\n"
            + "\tTIME_ELAPSED bigint(21) DEFAULT NULL,\n"
            + "\tTIME_RESET datetime DEFAULT NULL,\n"
            + "\tSTATUS varchar(193) DEFAULT '' NOT NULL,\n"
            + "\tTYPE varchar(193) DEFAULT '' NOT NULL,\n"
            + "\tCOMMENT varchar(193) DEFAULT '' NOT NULL\n"
            + ")";

    public static final String SPATIAL_REF_SYS_CREATE_TABLE_SQL = "CREATE TABLE `SPATIAL_REF_SYS` (\n"
            + "\tSRID smallint(5) DEFAULT 0 NOT NULL,\n"
            + "\tAUTH_NAME varchar(512) DEFAULT '' NOT NULL,\n"
            + "\tAUTH_SRID int(5) DEFAULT 0 NOT NULL,\n"
            + "\tSRTEXT varchar(2048) DEFAULT '' NOT NULL\n"
            + ")";

    public static final String INNODB_CMP_RESET_CREATE_TABLE_SQL = "CREATE TABLE `INNODB_CMP_RESET` (\n"
            + "\tpage_size int(5) DEFAULT 0 NOT NULL,\n"
            + "\tcompress_ops int(11) DEFAULT 0 NOT NULL,\n"
            + "\tcompress_ops_ok int(11) DEFAULT 0 NOT NULL,\n"
            + "\tcompress_time int(11) DEFAULT 0 NOT NULL,\n"
            + "\tuncompress_ops int(11) DEFAULT 0 NOT NULL,\n"
            + "\tuncompress_time int(11) DEFAULT 0 NOT NULL\n"
            + ")";

    public static final String INNODB_FT_INDEX_CACHE_CREATE_TABLE_SQL = "CREATE TABLE `INNODB_FT_INDEX_CACHE` (\n"
            + "\tWORD varchar(337) DEFAULT '' NOT NULL,\n"
            + "\tFIRST_DOC_ID bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tLAST_DOC_ID bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tDOC_COUNT bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tDOC_ID bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tPOSITION bigint(21) DEFAULT 0 NOT NULL\n"
            + ")";

    public static final String INNODB_SYS_INDEXES_CREATE_TABLE_SQL = "CREATE TABLE `INNODB_SYS_INDEXES` (\n"
            + "\tINDEX_ID bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tNAME varchar(193) DEFAULT '' NOT NULL,\n"
            + "\tTABLE_ID bigint(21) DEFAULT 0 NOT NULL,\n"
            + "\tTYPE int(11) DEFAULT 0 NOT NULL,\n"
            + "\tN_FIELDS int(11) DEFAULT 0 NOT NULL,\n"
            + "\tPAGE_NO int(11) DEFAULT 0 NOT NULL,\n"
            + "\tSPACE int(11) DEFAULT 0 NOT NULL,\n"
            + "\tMERGE_THRESHOLD int(11) DEFAULT 0 NOT NULL\n"
            + ")";

    public static final String USER_PRIVILEGES_CREATE_TABLE_SQL = "CREATE TABLE `USER_PRIVILEGES` (\n"
            + "\tGRANTEE varchar(190) DEFAULT '' NOT NULL,\n"
            + "\tTABLE_CATALOG varchar(512) DEFAULT '' NOT NULL,\n"
            + "\tPRIVILEGE_TYPE varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tIS_GRANTABLE varchar(3) DEFAULT '' NOT NULL\n"
            + ")";

    public static final String PROCESSLIST_CREATE_TABLE_SQL = "CREATE TABLE `PROCESSLIST` (\n"
            + "\tID bigint(4) DEFAULT 0 NOT NULL,\n"
            + "\tUSER varchar(128) DEFAULT '' NOT NULL,\n"
            + "\tHOST varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tDB varchar(64) DEFAULT NULL,\n"
            + "\tCOMMAND varchar(16) DEFAULT '' NOT NULL,\n"
            + "\tTIME int(7) DEFAULT 0 NOT NULL,\n"
            + "\tSTATE varchar(64) DEFAULT NULL,\n"
            + "\tINFO longtext DEFAULT NULL,\n"
            + "\tTIME_MS decimal(22, 3) DEFAULT 0.000 NOT NULL,\n"
            + "\tSTAGE tinyint(2) DEFAULT 0 NOT NULL,\n"
            + "\tMAX_STAGE tinyint(2) DEFAULT 0 NOT NULL,\n"
            + "\tPROGRESS decimal(7, 3) DEFAULT 0.000 NOT NULL,\n"
            + "\tMEMORY_USED bigint(7) DEFAULT 0 NOT NULL,\n"
            + "\tMAX_MEMORY_USED bigint(7) DEFAULT 0 NOT NULL,\n"
            + "\tEXAMINED_ROWS int(7) DEFAULT 0 NOT NULL,\n"
            + "\tQUERY_ID bigint(4) DEFAULT 0 NOT NULL,\n"
            + "\tINFO_BINARY blob DEFAULT NULL,\n"
            + "\tTID bigint(4) DEFAULT 0 NOT NULL\n"
            + ")";

    public static final String SCHEMA_PRIVILEGES_CREATE_TABLE_SQL = "CREATE TABLE `SCHEMA_PRIVILEGES` (\n"
            + "\tGRANTEE varchar(190) DEFAULT '' NOT NULL,\n"
            + "\tTABLE_CATALOG varchar(512) DEFAULT '' NOT NULL,\n"
            + "\tTABLE_SCHEMA varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tPRIVILEGE_TYPE varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tIS_GRANTABLE varchar(3) DEFAULT '' NOT NULL\n"
            + ")";

    public static final String ROUTINES_CREATE_TABLE_SQL = "CREATE TABLE `ROUTINES` (\n"
            + "\tSPECIFIC_NAME varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tROUTINE_CATALOG varchar(512) DEFAULT '' NOT NULL,\n"
            + "\tROUTINE_SCHEMA varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tROUTINE_NAME varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tROUTINE_TYPE varchar(13) DEFAULT '' NOT NULL,\n"
            + "\tDATA_TYPE varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tCHARACTER_MAXIMUM_LENGTH int(21) DEFAULT NULL,\n"
            + "\tCHARACTER_OCTET_LENGTH int(21) DEFAULT NULL,\n"
            + "\tNUMERIC_PRECISION int(21) DEFAULT NULL,\n"
            + "\tNUMERIC_SCALE int(21) DEFAULT NULL,\n"
            + "\tDATETIME_PRECISION bigint(21) DEFAULT NULL,\n"
            + "\tCHARACTER_SET_NAME varchar(64) DEFAULT NULL,\n"
            + "\tCOLLATION_NAME varchar(64) DEFAULT NULL,\n"
            + "\tDTD_IDENTIFIER longtext DEFAULT NULL,\n"
            + "\tROUTINE_BODY varchar(8) DEFAULT '' NOT NULL,\n"
            + "\tROUTINE_DEFINITION longtext DEFAULT NULL,\n"
            + "\tEXTERNAL_NAME varchar(64) DEFAULT NULL,\n"
            + "\tEXTERNAL_LANGUAGE varchar(64) DEFAULT NULL,\n"
            + "\tPARAMETER_STYLE varchar(8) DEFAULT '' NOT NULL,\n"
            + "\tIS_DETERMINISTIC varchar(3) DEFAULT '' NOT NULL,\n"
            + "\tSQL_DATA_ACCESS varchar(64) DEFAULT '' NOT NULL,\n"
            + "\tSQL_PATH varchar(64) DEFAULT NULL,\n"
            + "\tSECURITY_TYPE varchar(7) DEFAULT '' NOT NULL,\n"
            + "\tCREATED datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,\n"
            + "\tLAST_ALTERED datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,\n"
            + "\tSQL_MODE varchar(8192) DEFAULT '' NOT NULL,\n"
            + "\tROUTINE_COMMENT longtext DEFAULT '' NOT NULL,\n"
            + "\tDEFINER varchar(189) DEFAULT '' NOT NULL,\n"
            + "\tCHARACTER_SET_CLIENT varchar(32) DEFAULT '' NOT NULL,\n"
            + "\tCOLLATION_CONNECTION varchar(32) DEFAULT '' NOT NULL,\n"
            + "\tDATABASE_COLLATION varchar(32) DEFAULT '' NOT NULL\n"
            + ")";
}