/**
 * Copyright (C) <2020>  <chen junwen>
 * <p>
 * This program is free software: you can redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * <p>
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
 * even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * <p>
 * You should have received a copy of the GNU General Public License along with this program.  If
 * not, see <http://www.gnu.org/licenses/>.
 */
package io.mycat.calcite.table;

import io.mycat.calcite.rewriter.Distribution;
import org.apache.calcite.rex.RexNode;

import java.util.List;

//@Getter
public interface AbstractMycatTable {
    public abstract Distribution computeDataNode(List<RexNode> conditions);

    public abstract boolean isSingle(List<RexNode> conditions);

    public abstract Distribution computeDataNode();

    public default boolean isBroadCast() {
        return false;
    }

    public default boolean isNormal() {
        return false;
    }

    public default boolean isSharding() {
        return false;
    }

    public default boolean isCustom() {
        return false;
    }

    boolean isPartial(List<RexNode> conditions);
}